<?php
/*
bitpay Developement Team
*/

if (!isset($GLOBALS['vbulletin']->db))
{
	exit;
}

/**
* Class that provides payment verification and form generation functions
*
* @package	vBulletin
* @version	$Revision: 20000 $
* @date		$Date: 2012-04-24 18:57:45 +0350 (tue, 24 April 2012) $
*/
class vB_PaidSubscriptionMethod_bitpay extends vB_PaidSubscriptionMethod
{
	var $supports_recurring = false;
	var $display_feedback = true;

    function send($url,$api,$amount,$redirect){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"$url");
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"$url");
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }

	function verify_payment()
	{
		$this->registry->input->clean_array_gpc('r', array(
			'item'    => TYPE_STR,
			'trans_id'    => TYPE_STR,
            'id_get'    => TYPE_STR
		));

        $this->id_get = $_POST['id_get'];
		$this->transaction_id = $_POST['trans_id'];

		if(!empty($this->registry->GPC['item']) && !empty($this->transaction_id))
		{
			$this->paymentinfo = $this->registry->db->query_first("
				SELECT paymentinfo.*, user.username
				FROM " . TABLE_PREFIX . "paymentinfo AS paymentinfo
				INNER JOIN " . TABLE_PREFIX . "user AS user USING (userid)
				WHERE hash = '" . $this->registry->db->escape_string($this->registry->GPC['item']) . "'
			");
			if (!empty($this->paymentinfo))
			{
				$sub = $this->registry->db->query_first("SELECT * FROM " . TABLE_PREFIX . "subscription WHERE subscriptionid = " . $this->paymentinfo['subscriptionid']);

				$cost = unserialize($sub['cost']);
				$amount = floor($cost[0][cost][usd]*$this->settings['d2t'])*10;
				

                $url = 'https://bitpay.ir/payment/gateway-result-second';
                $trans_id = $_POST['trans_id'];
                $id_get = $_POST['id_get'];

                $result = $this->get($url,$this->settings['plmid'],$trans_id,$id_get);
				if($result == 1 && $amount == $_GET['amount_check'])
				{
					$this->paymentinfo['currency'] = 'usd';
					$this->paymentinfo['amount'] = $cost[0][cost][usd];
					$this->type = 1;
					return true;
				}
			}
		}
		$this->error = 'Duplicate transaction.';
		return false;
    }


	function generate_form_html($hash, $cost, $currency, $subinfo, $userinfo, $timeinfo)
	{
		global $vbphrase, $vbulletin, $show;

		$item = $hash;
		$cost = (floor($cost*$this->settings['d2t']))*10;
		$api = $this->settings['plmid'];

		$form['action'] = 'bitpay.php';
		$form['method'] = 'POST';

		$settings =& $this->settings;

		$templater = vB_Template::create('subscription_payment_bitpay');
	     	$templater->register('API', $api);
			$templater->register('cost', $cost);
			$templater->register('item', $item);
			$templater->register('subinfo', $subinfo);
			$templater->register('settings', $settings);
			$templater->register('userinfo', $userinfo);
		$form['hiddenfields'] .= $templater->render();
		return $form;
	}
}

?>